#include <cassert>
#include <csignal>
#include <cstdarg>
#include <cstdio>
#include <cstdlib>

#include "lines.h"

namespace {
    static FILE *fifo_in = stdin, *fifo_out = stdout;

    int __subtask_id, __n;
    const int QUERY = 1;
    const int ANSWER = 2;
    const int ANSWER_ERROR = 3;

    void my_fprintf(FILE *file, const char *format, ...) {
        va_list args;
        va_start(args, format);
        if (vfprintf(file, format, args) < 0) {
            exit(0);
        }
        va_end(args);
    }

    void my_fscanf(FILE *file, int expected, const char *format, ...) {
        va_list args;
        va_start(args, format);
        if (vfscanf(file, format, args) != expected) {
            exit(0);
        }
        va_end(args);
    }
}

long double query(long double x, long double y) {
    my_fprintf(fifo_out, "%d\n", QUERY);
    my_fprintf(fifo_out, "%.100Lf %.100Lf\n", x, y);
    fflush(fifo_out);

    long double answer;
    my_fscanf(fifo_in, 1, "%Lf", &answer);

    return answer;
}

void the_lines_are(std::vector<int> a, std::vector<int> b) {
    if (!(__n == a.size() && a.size() == b.size())) { 
        my_fprintf(fifo_out, "%d\n", ANSWER_ERROR);
    } else {
        my_fprintf(fifo_out, "%d\n", ANSWER);
        for (int i = 0; i < __n; ++i) {
            my_fprintf(fifo_out, "%d %d\n", a[i], b[i]);
        }
    }
    fflush(fifo_out);
    fclose(fifo_in);
    fclose(fifo_out);
    exit(0);
}

int main(int argc, char **argv) {
    my_fscanf(fifo_in, 2, "%d%d", &__subtask_id, &__n);
    solve(__subtask_id, __n);
    fclose(fifo_in);
    fclose(fifo_out);
    return 0;
}
